-- Compiled with roblox-ts v2.3.0-dev-576ad98
local TS = _G[script]
local HotReloader = TS.import(script, TS.getModule(script, "@rbxts", "rewire").out).HotReloader
local MatterHotReload
do
	MatterHotReload = setmetatable({}, {
		__tostring = function()
			return "MatterHotReload"
		end,
	})
	MatterHotReload.__index = MatterHotReload
	function MatterHotReload.new(...)
		local self = setmetatable({}, MatterHotReload)
		return self:constructor(...) or self
	end
	function MatterHotReload:constructor(loop, systemContainer)
		self.loop = loop
		self.systemContainer = systemContainer
		self.hotReloader = HotReloader.new()
		self.systemsByModule = {}
		self.firstRunSystems = {}
	end
	function MatterHotReload:hotReloadCallback(module, context)
		local originalModule = context.originalModule
		local originalSystem = self.systemsByModule[originalModule]
		local success, newSystem = pcall(require, module)
		if not success then
			error(newSystem)
		end
		if self.firstRunSystems then
			local _exp = self.firstRunSystems
			table.insert(_exp, newSystem)
		elseif originalSystem then
			self.loop:replaceSystem(originalSystem, newSystem)
		else
			self.loop:scheduleSystem(newSystem)
		end
		self.systemsByModule[originalModule] = newSystem
	end
	function MatterHotReload:hotReloadCleanup(_, context)
		if context.isReloading then
			return nil
		end
		local dyingModule = context.originalModule
		local dyingSystem = self.systemsByModule[dyingModule]
		if not dyingSystem then
			return nil
		end
		self.loop:evictSystem(dyingSystem)
		self.systemsByModule[dyingModule] = nil
	end
	function MatterHotReload:setupHotReload()
		self.hotReloader:scan(self.systemContainer, function(...)
			local args = { ... }
			return self:hotReloadCallback(unpack(args))
		end, function(...)
			local args = { ... }
			return self:hotReloadCleanup(unpack(args))
		end)
		if not self.firstRunSystems then
			error("firstRunSystems is undefined. Cannot fully setup hot reload.")
		end
		self.loop:scheduleSystems(self.firstRunSystems)
		self.firstRunSystems = nil
	end
end
return {
	default = MatterHotReload,
}
