-- Compiled with roblox-ts v2.3.0-dev-576ad98
local TS = _G[script]
local MATTER_REPLICATION_ROUTE_NAME = TS.import(script, script.Parent.Parent, "constants").MATTER_REPLICATION_ROUTE_NAME
local Object = TS.import(script, TS.getModule(script, "@rbxts", "object-utils"))
local ObjectUtils = TS.import(script, TS.getModule(script, "@rbxts", "gameutil").out).ObjectUtils
local function componentsReceiveSystemFactory(components)
	local entityIdMap = {}
	return {
		system = function(world, _, routes)
			if not routes then
				error("No routes passed to the componentsReceive system! Cannot proceed")
			end
			local worldReplicationRoute = routes[MATTER_REPLICATION_ROUTE_NAME]
			for _, _1, entities in worldReplicationRoute:query() do
				for _1, _binding in Object.entries(entities) do
					local serverEntityId = _binding[1]
					local componentMap = _binding[2]
					local clientEntityId = entityIdMap[serverEntityId]
					local _condition = clientEntityId
					if _condition ~= 0 and _condition == _condition and _condition then
						_condition = not { next(componentMap) }
					end
					if _condition then
						world:despawn(clientEntityId)
						entityIdMap[serverEntityId] = nil
						continue
					end
					local componentsToInsert = {}
					local componentsToRemove = {}
					for _2, _binding_1 in Object.entries(componentMap) do
						local name = _binding_1[1]
						local container = _binding_1[2]
						if container.data then
							local _arg0 = components[name](container.data)
							table.insert(componentsToInsert, _arg0)
						else
							local _arg0 = components[name]
							table.insert(componentsToRemove, _arg0)
						end
					end
					if not (clientEntityId ~= 0 and clientEntityId == clientEntityId and clientEntityId) then
						clientEntityId = world:spawn(unpack(componentsToInsert))
						local _clientEntityId = clientEntityId
						entityIdMap[serverEntityId] = _clientEntityId
					else
						if ObjectUtils.length(componentsToInsert) > 0 then
							world:insert(clientEntityId, unpack(componentsToInsert))
						end
						if ObjectUtils.length(componentsToRemove) > 0 then
							world:remove(clientEntityId, unpack(componentsToRemove))
						end
					end
				end
			end
		end,
		priority = math.huge,
	}
end
return {
	default = componentsReceiveSystemFactory,
}
