-- Compiled with roblox-ts v2.3.0-dev-576ad98
local TS = _G[script]
local _yetanothernet = TS.import(script, TS.getModule(script, "@rbxts", "yetanothernet").lib)
local Net = _yetanothernet
local Route = _yetanothernet.Route
local MATTER_REPLICATION_ROUTE_NAME = TS.import(script, script.Parent, "constants").MATTER_REPLICATION_ROUTE_NAME
local RunService = TS.import(script, TS.getModule(script, "@rbxts", "services")).RunService
local componentsReplicateSystemFactory = TS.import(script, script, "componentsReplicate").default
local componentsReceiveSystemFactory = TS.import(script, script, "componentsReceive").default
local MatterReplication
do
	MatterReplication = setmetatable({}, {
		__tostring = function()
			return "MatterReplication"
		end,
	})
	MatterReplication.__index = MatterReplication
	function MatterReplication.new(...)
		local self = setmetatable({}, MatterReplication)
		return self:constructor(...) or self
	end
	function MatterReplication:constructor(loop, routes, components)
		self.loop = loop
		self.routes = routes
		self.components = components
	end
	function MatterReplication:setupReplication()
		self.routes[MATTER_REPLICATION_ROUTE_NAME] = Route.new({
			Event = "default",
			Channel = "Reliable",
		})
		Net.start(self.loop, self.routes)
		self.loop:scheduleSystem(if RunService:IsServer() then componentsReplicateSystemFactory(self.components) else componentsReceiveSystemFactory(self.components))
	end
end
return {
	default = MatterReplication,
}
