-- Compiled with roblox-ts v2.3.0-dev-576ad98
local TS = _G[script]
local Reflect = TS.import(script, TS.getModule(script, "@rbxts", "experimental-reflect").out).Reflect
local Object = TS.import(script, TS.getModule(script, "@rbxts", "object-utils"))
--[[
	*
	 * Fetches components decorating with ``decorationKey`` within a list of components
	 * 
	 * @param components The list of components
	 * @param decorationKey The metadata key that the decorator applies
	 * @returns A subset of ``components`` including only components that are marked as decorated with ``decorationKey``
	 
]]
local decoratedComponentsIn = function(components, decorationKey)
	local decoratedComponents = {}
	for _, _binding in Object.entries(components) do
		local componentKey = _binding[1]
		local component = _binding[2]
		local isDecorated = Reflect.getMetadata(decorationKey, components, componentKey)
		if not (isDecorated ~= 0 and isDecorated == isDecorated and isDecorated ~= "" and isDecorated) then
			continue
		end
		decoratedComponents[componentKey] = component
	end
	return decoratedComponents
end
return {
	decoratedComponentsIn = decoratedComponentsIn,
}
